<template>
  <transition
    enter-active-class="animated fadeIn fast"
    leave-active-class="animated fadeOut fast"
  >
    <div
      v-show="show"
      class="w-full border-t fixed pin-b bg-white p-2 flex items-center justify-between status-bar"
    >
      <p class="flex items-center">
        {{ status.message }}
        <icon
          v-if="status.loading"
          class="ml-2"
          name="spinner"
          pulse
        />
      </p>

      <div @click="hide">
        <icon
          name="times"
          color="grey"
          class="cursor-pointer"
        />
      </div>
    </div>
  </transition>
</template>

<style lang="postcss" scoped>
.status-bar {
  box-shadow: 0 -2px 4px 0 rgba(0,0,0,0.12);
}
</style>

<script lang="ts">
import { Vue, Component, Watch } from 'vue-property-decorator'
import { State } from 'vuex-class'

import 'vue-awesome/icons/times'
import 'vue-awesome/icons/spinner'
import Icon from 'vue-awesome/components/Icon.vue'

@Component({
  components: {
    Icon
  }
})
export default class StatusBar extends Vue {
  @State status: any

  show = false

  @Watch('status')
  onStatusChanged () {
    this.show = true
  }

  hide () {
    this.show = false
  }
}
</script>
